diff -urN qmail-1.03-vanilla/qreceipt.c qmail-1.03-md24/qreceipt.c
--- qmail-1.03-vanilla/qreceipt.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qreceipt.c	2007-07-19 20:56:22.000000000 +0200
@@ -92,9 +92,10 @@
  qmail_to(&qqt,returnpath);
  qqx = qmail_close(&qqt);
 
- if (*qqx)
+ if (*qqx) {
    if (*qqx == 'D') die_qqperm();
    else die_qqtemp();
+ }
 }
 
 stralloc hfbuf = {0};
@@ -119,7 +120,7 @@
 
 void dobody(h) stralloc *h; { ; }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -128,4 +129,5 @@
  if (!(returnpath = env_get("SENDER"))) die_usage();
  if (headerbody(subfdin,doheaderfield,finishheader,dobody) == -1) die_read();
  die_noreceipt();
+ return 0;
 }
diff -urN qmail-1.03-vanilla/qsmhook.c qmail-1.03-md24/qsmhook.c
--- qmail-1.03-vanilla/qsmhook.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qsmhook.c	2007-07-19 20:56:22.000000000 +0200
@@ -35,7 +35,7 @@
 substdio ssin;
 char inbuf[SUBSTDIO_INSIZE];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -78,7 +78,7 @@
 
  if (!*argv) die_usage();
 
- for (arg = argv;x = *arg;++arg)
+ for (arg = argv;(x = *arg);++arg)
   {
    if (!stralloc_copys(&newarg,"")) die_temp();
    flagesc = 0;
diff -urN qmail-1.03-vanilla/qsutil.c qmail-1.03-md24/qsutil.c
--- qmail-1.03-vanilla/qsutil.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qsutil.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "stralloc.h"
 #include "readwrite.h"
 #include "substdio.h"
diff -urN qmail-1.03-vanilla/rcpthosts.c qmail-1.03-md24/rcpthosts.c
--- qmail-1.03-vanilla/rcpthosts.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/rcpthosts.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include "cdb.h"
 #include "byte.h"
+#include "case.h"
 #include "open.h"
 #include "error.h"
 #include "control.h"
diff -urN qmail-1.03-vanilla/readwrite.h qmail-1.03-md24/readwrite.h
--- qmail-1.03-vanilla/readwrite.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/readwrite.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,6 @@
 #ifndef READWRITE_H
 #define READWRITE_H
 
-extern int read();
-extern int write();
+#include <unistd.h>
 
 #endif
diff -urN qmail-1.03-vanilla/realrcptto.c qmail-1.03-md24/realrcptto.c
--- qmail-1.03-vanilla/realrcptto.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/realrcptto.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,282 @@
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <pwd.h>
+#include "auto_break.h"
+#include "auto_usera.h"
+#include "byte.h"
+#include "case.h"
+#include "cdb.h"
+#include "constmap.h"
+#include "error.h"
+#include "control.h"
+#include "fmt.h"
+#include "open.h"
+#include "str.h"
+#include "stralloc.h"
+#include "uint32.h"
+#include "substdio.h"
+#include "env.h"
+
+extern void die_nomem();
+extern void die_control();
+extern void die_cdb();
+extern void die_sys();
+
+static stralloc envnoathost = {0};
+static stralloc percenthack = {0};
+static stralloc locals = {0};
+static stralloc vdoms = {0};
+static struct constmap mappercenthack;
+static struct constmap maplocals;
+static struct constmap mapvdoms;
+
+static char *dash;
+static char *extension;
+static char *local;
+static struct passwd *pw;
+
+static char pidbuf[64];
+static char remoteipbuf[64]=" ";
+
+void realrcptto_init()
+{
+  char *x;
+
+  if (control_rldef(&envnoathost,"control/envnoathost",1,"envnoathost") != 1)
+    die_control();
+
+  if (control_readfile(&locals,"control/locals",1) != 1) die_control();
+  if (!constmap_init(&maplocals,locals.s,locals.len,0)) die_nomem();
+  switch(control_readfile(&percenthack,"control/percenthack",0)) {
+    case -1: die_control();
+    case 0: if (!constmap_init(&mappercenthack,"",0,0)) die_nomem();
+    case 1:
+      if (!constmap_init(&mappercenthack,percenthack.s,percenthack.len,0))
+        die_nomem();
+  }
+  switch(control_readfile(&vdoms,"control/virtualdomains",0)) {
+    case -1: die_control();
+    case 0: if (!constmap_init(&mapvdoms,"",0,1)) die_nomem();
+    case 1: if (!constmap_init(&mapvdoms,vdoms.s,vdoms.len,1)) die_nomem();
+  }
+
+  str_copy(pidbuf + fmt_ulong(pidbuf,getpid())," ");
+  x=env_get("PROTO");
+  if (x) {
+    static char const remoteip[]="REMOTEIP";
+    unsigned int len = str_len(x);
+    if (len <= sizeof remoteipbuf - sizeof remoteip) {
+      byte_copy(remoteipbuf,len,x);
+      byte_copy(remoteipbuf + len,sizeof remoteip,remoteip);
+      x = env_get(remoteipbuf);
+      len = str_len(x);
+      if (len + 1 < sizeof remoteipbuf) {
+        byte_copy(remoteipbuf,len,x);
+        remoteipbuf[len]=' ';
+        remoteipbuf[len + 1]='\0';
+      }
+    }
+  }
+}
+
+#define GETPW_USERLEN 32
+
+static int userext()
+{
+  char username[GETPW_USERLEN];
+  struct stat st;
+
+  extension = local + str_len(local);
+  for (;;) {
+    if (extension - local < sizeof(username))
+      if (!*extension || (*extension == *auto_break)) {
+	byte_copy(username,extension - local,local);
+	username[extension - local] = 0;
+	case_lowers(username);
+	errno = 0;
+	pw = getpwnam(username);
+	if (errno == error_txtbsy) die_sys();
+	if (pw)
+	  if (pw->pw_uid)
+	    if (stat(pw->pw_dir,&st) == 0) {
+	      if (st.st_uid == pw->pw_uid) {
+		dash = "";
+		if (*extension) { ++extension; dash = "-"; }
+		return 1;
+	      }
+	    }
+	    else
+	      if (error_temp(errno)) die_sys();
+      }
+    if (extension == local) return 0;
+    --extension;
+  }
+}
+
+int realrcptto(addr)
+char *addr;
+{
+  char *homedir;
+  static stralloc localpart = {0};
+  static stralloc lower = {0};
+  static stralloc nughde = {0};
+  static stralloc wildchars = {0};
+  static stralloc safeext = {0};
+  static stralloc qme = {0};
+
+  /* qmail-send:rewrite */
+  unsigned int i,at;
+  if (!stralloc_copys(&localpart,addr)) die_nomem();
+  i = byte_rchr(localpart.s,localpart.len,'@');
+  if (i == localpart.len) {
+    if (!stralloc_cats(&localpart,"@")) die_nomem();
+    if (!stralloc_cat(&localpart,&envnoathost)) die_nomem();
+  }
+  while (constmap(&mappercenthack,localpart.s + i + 1,localpart.len - i - 1)) {
+    unsigned int j = byte_rchr(localpart.s,i,'%');
+    if (j == i) break;
+    localpart.len = i;
+    i = j;
+    localpart.s[i] = '@';
+  }
+  at = byte_rchr(localpart.s,localpart.len,'@');
+  if (constmap(&maplocals,localpart.s + at + 1,localpart.len - at - 1)) {
+    localpart.len = at;
+    localpart.s[at] = '\0';
+  } else {
+    unsigned int xlen,newlen;
+    char *x;
+    for (i = 0;;++i) {
+      if (i > localpart.len) return 1;
+      if (!i || (i == at + 1) || (i == localpart.len) ||
+          ((i > at) && (localpart.s[i] == '.'))) {
+        x = constmap(&mapvdoms,localpart.s + i,localpart.len - i);
+        if (x) break;
+      }
+    }
+    if (!*x) return 1;
+    xlen = str_len(x) + 1;  /* +1 for '-' */
+    newlen = xlen + at + 1; /* +1 for \0 */
+    if (xlen < 1 || newlen - 1 < xlen || newlen < 1 ||
+        !stralloc_ready(&localpart,newlen))
+      die_nomem();
+    localpart.s[newlen - 1] = '\0';
+    byte_copyr(localpart.s + xlen,at,localpart.s);
+    localpart.s[xlen - 1] = '-';
+    byte_copy(localpart.s,xlen - 1,x);
+    localpart.len = newlen;
+  }
+
+  /* qmail-lspawn:nughde_get */
+  {
+    int r,fd,flagwild;
+    if (!stralloc_copys(&lower,"!")) die_nomem();
+    if (!stralloc_cats(&lower,localpart.s)) die_nomem();
+    if (!stralloc_0(&lower)) die_nomem();
+    case_lowerb(lower.s,lower.len);
+    if (!stralloc_copys(&nughde,"")) die_nomem();
+    fd = open_read("users/cdb");
+    if (fd == -1) {
+      if (errno != error_noent) die_cdb();
+    } else {
+      uint32 dlen;
+      r = cdb_seek(fd,"",0,&dlen);
+      if (r != 1) die_cdb();
+      if (!stralloc_ready(&wildchars,(unsigned int) dlen)) die_nomem();
+      wildchars.len = dlen;
+      if (cdb_bread(fd,wildchars.s,wildchars.len) == -1) die_cdb();
+      i = lower.len;
+      flagwild = 0;
+      do { /* i > 0 */
+        if (!flagwild || (i == 1) ||
+            (byte_chr(wildchars.s,wildchars.len,lower.s[i - 1])
+             < wildchars.len)) {
+          r = cdb_seek(fd,lower.s,i,&dlen);
+          if (r == -1) die_cdb();
+          if (r == 1) {
+            char *x;
+            if (!stralloc_ready(&nughde,(unsigned int) dlen)) die_nomem();
+            nughde.len = dlen;
+            if (cdb_bread(fd,nughde.s,nughde.len) == -1) die_cdb();
+            if (flagwild)
+              if (!stralloc_cats(&nughde,localpart.s + i - 1)) die_nomem();
+            if (!stralloc_0(&nughde)) die_nomem();
+            close(fd);
+            x=nughde.s;
+            /* skip username */
+            x += byte_chr(x,nughde.s + nughde.len - x,'\0');
+            if (x == nughde.s + nughde.len) return 1;
+            ++x;
+            /* skip uid */
+            x += byte_chr(x,nughde.s + nughde.len - x,'\0');
+            if (x == nughde.s + nughde.len) return 1;
+            ++x;
+            /* skip gid */
+            x += byte_chr(x,nughde.s + nughde.len - x,'\0');
+            if (x == nughde.s + nughde.len) return 1;
+            ++x;
+            /* skip homedir */
+            homedir=x;
+            x += byte_chr(x,nughde.s + nughde.len - x,'\0');
+            if (x == nughde.s + nughde.len) return 1;
+            ++x;
+            /* skip dash */
+            dash=x;
+            x += byte_chr(x,nughde.s + nughde.len - x,'\0');
+            if (x == nughde.s + nughde.len) return 1;
+            ++x;
+            extension=x;
+            goto got_nughde;
+          }
+        }
+        --i;
+        flagwild = 1;
+      } while (i);
+      close(fd);
+    }
+  }
+
+  /* qmail-getpw */
+  local = localpart.s;
+  if (!userext()) {
+    extension = local;
+    dash = "-";
+    pw = getpwnam(auto_usera);
+  }
+  if (!pw) { return 0; }
+  if (!stralloc_copys(&nughde,pw->pw_dir)) die_nomem();
+  if (!stralloc_0(&nughde)) die_nomem();
+  homedir=nughde.s;
+
+  got_nughde:
+
+  /* qmail-local:qmesearch */
+  if (!*dash) return 1;
+  if (!stralloc_copys(&safeext,extension)) die_nomem();
+  case_lowerb(safeext.s,safeext.len);
+  for (i = 0;i < safeext.len;++i)
+    if (safeext.s[i] == '.')
+      safeext.s[i] = ':';
+  {
+    struct stat st;
+    int i;
+    if (!stralloc_copys(&qme,homedir)) die_nomem();
+    if (!stralloc_cats(&qme,"/.qmail")) die_nomem();
+    if (!stralloc_cats(&qme,dash)) die_nomem();
+    if (!stralloc_cat(&qme,&safeext)) die_nomem();
+    if (!stralloc_0(&qme)) die_nomem();
+    if (stat(qme.s, &st) == 0 || errno != error_noent) return 1;
+    for (i = safeext.len;i >= 0;--i)
+      if (!i || (safeext.s[i - 1] == '-')) {
+        if (!stralloc_copys(&qme,homedir)) die_nomem();
+        if (!stralloc_cats(&qme,"/.qmail")) die_nomem();
+        if (!stralloc_cats(&qme,dash)) die_nomem();
+        if (!stralloc_catb(&qme,safeext.s,i)) die_nomem();
+        if (!stralloc_cats(&qme,"default")) die_nomem();
+        if (!stralloc_0(&qme)) die_nomem();
+        if (stat(qme.s, &st) == 0 || errno != error_noent) return 1;
+      }
+    return 0;
+  }
+}
diff -urN qmail-1.03-vanilla/received.c qmail-1.03-md24/received.c
--- qmail-1.03-vanilla/received.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/received.c	2007-07-19 20:56:22.000000000 +0200
@@ -26,7 +26,7 @@
 char *s;
 {
   char ch;
-  while (ch = *s++) {
+  while ((ch = *s++)) {
     if (!issafe(ch)) ch = '?';
     qmail_put(qqt,&ch,1);
   }
diff -urN qmail-1.03-vanilla/received.h qmail-1.03-md24/received.h
--- qmail-1.03-vanilla/received.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/received.h	2007-07-19 20:56:22.000000000 +0200
@@ -2,5 +2,6 @@
 #define RECEIVED_H
 
 extern void received();
+extern void safeput();
 
 #endif
diff -urN qmail-1.03-vanilla/remoteinfo.c qmail-1.03-md24/remoteinfo.c
--- qmail-1.03-vanilla/remoteinfo.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/remoteinfo.c	2007-07-19 20:56:22.000000000 +0200
@@ -32,7 +32,6 @@
 {
   char *x;
   int s;
-  struct sockaddr_in sin;
   substdio ss;
   char buf[32];
   unsigned int len;
@@ -44,12 +43,7 @@
   s = socket(AF_INET,SOCK_STREAM,0);
   if (s == -1) return 0;
  
-  byte_zero(&sin,sizeof(sin));
-  sin.sin_family = AF_INET;
-  byte_copy(&sin.sin_addr,4,ipl);
-  sin.sin_port = 0;
-  if (bind(s,(struct sockaddr *) &sin,sizeof(sin)) == -1) { close(s); return 0; }
-  if (timeoutconn(s,ipr,113,timeout) == -1) { close(s); return 0; }
+  if (timeoutconn(s,ipr,ipl,113,timeout) == -1) { close(s); return 0; }
   fcntl(s,F_SETFL,fcntl(s,F_GETFL,0) & ~O_NDELAY);
  
   len = 0;
diff -urN qmail-1.03-vanilla/ripemd.c qmail-1.03-md24/ripemd.c
--- qmail-1.03-vanilla/ripemd.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/ripemd.c	2007-07-19 22:29:46.000000000 +0200
@@ -0,0 +1,353 @@
+#include "ripemd.h"
+
+static void compress(RIPEMD160_CTX *ctx);
+
+/* ROL(x, n) cyclically rotates x over n bits to the left */
+/* x must be of an unsigned 32 bits type and 0 <= n < 32. */
+#define ROL(x, n)   (((x) << (n)) | ((x) >> (32-(n))))
+
+/* the five basic functions F(), G() and H() */
+#define F(x, y, z)  ((x) ^ (y) ^ (z))
+#define G(x, y, z)  (((x) & (y)) | (~(x) & (z)))
+#define H(x, y, z)  (((x) | ~(y)) ^ (z))
+#define I(x, y, z)  (((x) & (z)) | ((y) & ~(z)))
+#define J(x, y, z)  ((x) ^ ((y) | ~(z)))
+
+/* the ten basic operations FF() through III() */
+#define FF(a, b, c, d, e, x, s) {\
+ (a) += F((b), (c), (d)) + (x);\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define GG(a, b, c, d, e, x, s)  {\
+ (a) += G((b), (c), (d)) + (x) + 0x5a827999UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define HH(a, b, c, d, e, x, s)  {\
+ (a) += H((b), (c), (d)) + (x) + 0x6ed9eba1UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define II(a, b, c, d, e, x, s)  {\
+ (a) += I((b), (c), (d)) + (x) + 0x8f1bbcdcUL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define JJ(a, b, c, d, e, x, s)  {\
+ (a) += J((b), (c), (d)) + (x) + 0xa953fd4eUL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define FFF(a, b, c, d, e, x, s) {\
+ (a) += F((b), (c), (d)) + (x);\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define GGG(a, b, c, d, e, x, s) {\
+ (a) += G((b), (c), (d)) + (x) + 0x7a6d76e9UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define HHH(a, b, c, d, e, x, s) {\
+ (a) += H((b), (c), (d)) + (x) + 0x6d703ef3UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define III(a, b, c, d, e, x, s) {\
+ (a) += I((b), (c), (d)) + (x) + 0x5c4dd124UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+#define JJJ(a, b, c, d, e, x, s) {\
+ (a) += J((b), (c), (d)) + (x) + 0x50a28be6UL;\
+ (a) = ROL((a), (s)) + (e);\
+ (c) = ROL((c), 10); }
+
+/* collect four u8s into one word: */
+#define bytes_TO_u32(strptr)    \
+ (((u32) *((strptr)+3) << 24) | \
+  ((u32) *((strptr)+2) << 16) | \
+  ((u32) *((strptr)+1) <<  8) | \
+  ((u32) *(strptr)))
+
+static void compress(RIPEMD160_CTX *ctx)
+{
+	u32 aa = ctx->MD[0], aaa = ctx->MD[0];
+	u32 bb = ctx->MD[1], bbb = ctx->MD[1];
+	u32 cc = ctx->MD[2], ccc = ctx->MD[2];
+	u32 dd = ctx->MD[3], ddd = ctx->MD[3];
+	u32 ee = ctx->MD[4], eee = ctx->MD[4];
+
+	/* round 1 */
+	FF(aa, bb, cc, dd, ee, ctx->X[ 0], 11);
+	FF(ee, aa, bb, cc, dd, ctx->X[ 1], 14);
+	FF(dd, ee, aa, bb, cc, ctx->X[ 2], 15);
+	FF(cc, dd, ee, aa, bb, ctx->X[ 3], 12);
+	FF(bb, cc, dd, ee, aa, ctx->X[ 4],  5);
+	FF(aa, bb, cc, dd, ee, ctx->X[ 5],  8);
+	FF(ee, aa, bb, cc, dd, ctx->X[ 6],  7);
+	FF(dd, ee, aa, bb, cc, ctx->X[ 7],  9);
+	FF(cc, dd, ee, aa, bb, ctx->X[ 8], 11);
+	FF(bb, cc, dd, ee, aa, ctx->X[ 9], 13);
+	FF(aa, bb, cc, dd, ee, ctx->X[10], 14);
+	FF(ee, aa, bb, cc, dd, ctx->X[11], 15);
+	FF(dd, ee, aa, bb, cc, ctx->X[12],  6);
+	FF(cc, dd, ee, aa, bb, ctx->X[13],  7);
+	FF(bb, cc, dd, ee, aa, ctx->X[14],  9);
+	FF(aa, bb, cc, dd, ee, ctx->X[15],  8);
+
+	/* round 2 */
+	GG(ee, aa, bb, cc, dd, ctx->X[ 7],  7);
+	GG(dd, ee, aa, bb, cc, ctx->X[ 4],  6);
+	GG(cc, dd, ee, aa, bb, ctx->X[13],  8);
+	GG(bb, cc, dd, ee, aa, ctx->X[ 1], 13);
+	GG(aa, bb, cc, dd, ee, ctx->X[10], 11);
+	GG(ee, aa, bb, cc, dd, ctx->X[ 6],  9);
+	GG(dd, ee, aa, bb, cc, ctx->X[15],  7);
+	GG(cc, dd, ee, aa, bb, ctx->X[ 3], 15);
+	GG(bb, cc, dd, ee, aa, ctx->X[12],  7);
+	GG(aa, bb, cc, dd, ee, ctx->X[ 0], 12);
+	GG(ee, aa, bb, cc, dd, ctx->X[ 9], 15);
+	GG(dd, ee, aa, bb, cc, ctx->X[ 5],  9);
+	GG(cc, dd, ee, aa, bb, ctx->X[ 2], 11);
+	GG(bb, cc, dd, ee, aa, ctx->X[14],  7);
+	GG(aa, bb, cc, dd, ee, ctx->X[11], 13);
+	GG(ee, aa, bb, cc, dd, ctx->X[ 8], 12);
+
+	/* round 3 */
+	HH(dd, ee, aa, bb, cc, ctx->X[ 3], 11);
+	HH(cc, dd, ee, aa, bb, ctx->X[10], 13);
+	HH(bb, cc, dd, ee, aa, ctx->X[14],  6);
+	HH(aa, bb, cc, dd, ee, ctx->X[ 4],  7);
+	HH(ee, aa, bb, cc, dd, ctx->X[ 9], 14);
+	HH(dd, ee, aa, bb, cc, ctx->X[15],  9);
+	HH(cc, dd, ee, aa, bb, ctx->X[ 8], 13);
+	HH(bb, cc, dd, ee, aa, ctx->X[ 1], 15);
+	HH(aa, bb, cc, dd, ee, ctx->X[ 2], 14);
+	HH(ee, aa, bb, cc, dd, ctx->X[ 7],  8);
+	HH(dd, ee, aa, bb, cc, ctx->X[ 0], 13);
+	HH(cc, dd, ee, aa, bb, ctx->X[ 6],  6);
+	HH(bb, cc, dd, ee, aa, ctx->X[13],  5);
+	HH(aa, bb, cc, dd, ee, ctx->X[11], 12);
+	HH(ee, aa, bb, cc, dd, ctx->X[ 5],  7);
+	HH(dd, ee, aa, bb, cc, ctx->X[12],  5);
+
+	/* round 4 */
+	II(cc, dd, ee, aa, bb, ctx->X[ 1], 11);
+	II(bb, cc, dd, ee, aa, ctx->X[ 9], 12);
+	II(aa, bb, cc, dd, ee, ctx->X[11], 14);
+	II(ee, aa, bb, cc, dd, ctx->X[10], 15);
+	II(dd, ee, aa, bb, cc, ctx->X[ 0], 14);
+	II(cc, dd, ee, aa, bb, ctx->X[ 8], 15);
+	II(bb, cc, dd, ee, aa, ctx->X[12],  9);
+	II(aa, bb, cc, dd, ee, ctx->X[ 4],  8);
+	II(ee, aa, bb, cc, dd, ctx->X[13],  9);
+	II(dd, ee, aa, bb, cc, ctx->X[ 3], 14);
+	II(cc, dd, ee, aa, bb, ctx->X[ 7],  5);
+	II(bb, cc, dd, ee, aa, ctx->X[15],  6);
+	II(aa, bb, cc, dd, ee, ctx->X[14],  8);
+	II(ee, aa, bb, cc, dd, ctx->X[ 5],  6);
+	II(dd, ee, aa, bb, cc, ctx->X[ 6],  5);
+	II(cc, dd, ee, aa, bb, ctx->X[ 2], 12);
+
+	/* round 5 */
+	JJ(bb, cc, dd, ee, aa, ctx->X[ 4],  9);
+	JJ(aa, bb, cc, dd, ee, ctx->X[ 0], 15);
+	JJ(ee, aa, bb, cc, dd, ctx->X[ 5],  5);
+	JJ(dd, ee, aa, bb, cc, ctx->X[ 9], 11);
+	JJ(cc, dd, ee, aa, bb, ctx->X[ 7],  6);
+	JJ(bb, cc, dd, ee, aa, ctx->X[12],  8);
+	JJ(aa, bb, cc, dd, ee, ctx->X[ 2], 13);
+	JJ(ee, aa, bb, cc, dd, ctx->X[10], 12);
+	JJ(dd, ee, aa, bb, cc, ctx->X[14],  5);
+	JJ(cc, dd, ee, aa, bb, ctx->X[ 1], 12);
+	JJ(bb, cc, dd, ee, aa, ctx->X[ 3], 13);
+	JJ(aa, bb, cc, dd, ee, ctx->X[ 8], 14);
+	JJ(ee, aa, bb, cc, dd, ctx->X[11], 11);
+	JJ(dd, ee, aa, bb, cc, ctx->X[ 6],  8);
+	JJ(cc, dd, ee, aa, bb, ctx->X[15],  5);
+	JJ(bb, cc, dd, ee, aa, ctx->X[13],  6);
+
+	/* parallel round 1 */
+	JJJ(aaa, bbb, ccc, ddd, eee, ctx->X[ 5],  8);
+	JJJ(eee, aaa, bbb, ccc, ddd, ctx->X[14],  9);
+	JJJ(ddd, eee, aaa, bbb, ccc, ctx->X[ 7],  9);
+	JJJ(ccc, ddd, eee, aaa, bbb, ctx->X[ 0], 11);
+	JJJ(bbb, ccc, ddd, eee, aaa, ctx->X[ 9], 13);
+	JJJ(aaa, bbb, ccc, ddd, eee, ctx->X[ 2], 15);
+	JJJ(eee, aaa, bbb, ccc, ddd, ctx->X[11], 15);
+	JJJ(ddd, eee, aaa, bbb, ccc, ctx->X[ 4],  5);
+	JJJ(ccc, ddd, eee, aaa, bbb, ctx->X[13],  7);
+	JJJ(bbb, ccc, ddd, eee, aaa, ctx->X[ 6],  7);
+	JJJ(aaa, bbb, ccc, ddd, eee, ctx->X[15],  8);
+	JJJ(eee, aaa, bbb, ccc, ddd, ctx->X[ 8], 11);
+	JJJ(ddd, eee, aaa, bbb, ccc, ctx->X[ 1], 14);
+	JJJ(ccc, ddd, eee, aaa, bbb, ctx->X[10], 14);
+	JJJ(bbb, ccc, ddd, eee, aaa, ctx->X[ 3], 12);
+	JJJ(aaa, bbb, ccc, ddd, eee, ctx->X[12],  6);
+
+	/* parallel round 2 */
+	III(eee, aaa, bbb, ccc, ddd, ctx->X[ 6],  9); 
+	III(ddd, eee, aaa, bbb, ccc, ctx->X[11], 13);
+	III(ccc, ddd, eee, aaa, bbb, ctx->X[ 3], 15);
+	III(bbb, ccc, ddd, eee, aaa, ctx->X[ 7],  7);
+	III(aaa, bbb, ccc, ddd, eee, ctx->X[ 0], 12);
+	III(eee, aaa, bbb, ccc, ddd, ctx->X[13],  8);
+	III(ddd, eee, aaa, bbb, ccc, ctx->X[ 5],  9);
+	III(ccc, ddd, eee, aaa, bbb, ctx->X[10], 11);
+	III(bbb, ccc, ddd, eee, aaa, ctx->X[14],  7);
+	III(aaa, bbb, ccc, ddd, eee, ctx->X[15],  7);
+	III(eee, aaa, bbb, ccc, ddd, ctx->X[ 8], 12);
+	III(ddd, eee, aaa, bbb, ccc, ctx->X[12],  7);
+	III(ccc, ddd, eee, aaa, bbb, ctx->X[ 4],  6);
+	III(bbb, ccc, ddd, eee, aaa, ctx->X[ 9], 15);
+	III(aaa, bbb, ccc, ddd, eee, ctx->X[ 1], 13);
+	III(eee, aaa, bbb, ccc, ddd, ctx->X[ 2], 11);
+
+	/* parallel round 3 */
+	HHH(ddd, eee, aaa, bbb, ccc, ctx->X[15],  9);
+	HHH(ccc, ddd, eee, aaa, bbb, ctx->X[ 5],  7);
+	HHH(bbb, ccc, ddd, eee, aaa, ctx->X[ 1], 15);
+	HHH(aaa, bbb, ccc, ddd, eee, ctx->X[ 3], 11);
+	HHH(eee, aaa, bbb, ccc, ddd, ctx->X[ 7],  8);
+	HHH(ddd, eee, aaa, bbb, ccc, ctx->X[14],  6);
+	HHH(ccc, ddd, eee, aaa, bbb, ctx->X[ 6],  6);
+	HHH(bbb, ccc, ddd, eee, aaa, ctx->X[ 9], 14);
+	HHH(aaa, bbb, ccc, ddd, eee, ctx->X[11], 12);
+	HHH(eee, aaa, bbb, ccc, ddd, ctx->X[ 8], 13);
+	HHH(ddd, eee, aaa, bbb, ccc, ctx->X[12],  5);
+	HHH(ccc, ddd, eee, aaa, bbb, ctx->X[ 2], 14);
+	HHH(bbb, ccc, ddd, eee, aaa, ctx->X[10], 13);
+	HHH(aaa, bbb, ccc, ddd, eee, ctx->X[ 0], 13);
+	HHH(eee, aaa, bbb, ccc, ddd, ctx->X[ 4],  7);
+	HHH(ddd, eee, aaa, bbb, ccc, ctx->X[13],  5);
+
+	/* parallel round 4 */   
+	GGG(ccc, ddd, eee, aaa, bbb, ctx->X[ 8], 15);
+	GGG(bbb, ccc, ddd, eee, aaa, ctx->X[ 6],  5);
+	GGG(aaa, bbb, ccc, ddd, eee, ctx->X[ 4],  8);
+	GGG(eee, aaa, bbb, ccc, ddd, ctx->X[ 1], 11);
+	GGG(ddd, eee, aaa, bbb, ccc, ctx->X[ 3], 14);
+	GGG(ccc, ddd, eee, aaa, bbb, ctx->X[11], 14);
+	GGG(bbb, ccc, ddd, eee, aaa, ctx->X[15],  6);
+	GGG(aaa, bbb, ccc, ddd, eee, ctx->X[ 0], 14);
+	GGG(eee, aaa, bbb, ccc, ddd, ctx->X[ 5],  6);
+	GGG(ddd, eee, aaa, bbb, ccc, ctx->X[12],  9);
+	GGG(ccc, ddd, eee, aaa, bbb, ctx->X[ 2], 12);
+	GGG(bbb, ccc, ddd, eee, aaa, ctx->X[13],  9);
+	GGG(aaa, bbb, ccc, ddd, eee, ctx->X[ 9], 12);
+	GGG(eee, aaa, bbb, ccc, ddd, ctx->X[ 7],  5);
+	GGG(ddd, eee, aaa, bbb, ccc, ctx->X[10], 15);
+	GGG(ccc, ddd, eee, aaa, bbb, ctx->X[14],  8);
+
+	/* parallel round 5 */
+	FFF(bbb, ccc, ddd, eee, aaa, ctx->X[12] ,  8);
+	FFF(aaa, bbb, ccc, ddd, eee, ctx->X[15] ,  5);
+	FFF(eee, aaa, bbb, ccc, ddd, ctx->X[10] , 12);
+	FFF(ddd, eee, aaa, bbb, ccc, ctx->X[ 4] ,  9);
+	FFF(ccc, ddd, eee, aaa, bbb, ctx->X[ 1] , 12);
+	FFF(bbb, ccc, ddd, eee, aaa, ctx->X[ 5] ,  5);
+	FFF(aaa, bbb, ccc, ddd, eee, ctx->X[ 8] , 14);
+	FFF(eee, aaa, bbb, ccc, ddd, ctx->X[ 7] ,  6);
+	FFF(ddd, eee, aaa, bbb, ccc, ctx->X[ 6] ,  8);
+	FFF(ccc, ddd, eee, aaa, bbb, ctx->X[ 2] , 13);
+	FFF(bbb, ccc, ddd, eee, aaa, ctx->X[13] ,  6);
+	FFF(aaa, bbb, ccc, ddd, eee, ctx->X[14] ,  5);
+	FFF(eee, aaa, bbb, ccc, ddd, ctx->X[ 0] , 15);
+	FFF(ddd, eee, aaa, bbb, ccc, ctx->X[ 3] , 13);
+	FFF(ccc, ddd, eee, aaa, bbb, ctx->X[ 9] , 11);
+	FFF(bbb, ccc, ddd, eee, aaa, ctx->X[11] , 11);
+
+	/* combine results */
+	ddd += cc + ctx->MD[1];
+	ctx->MD[1] = ctx->MD[2] + dd + eee;
+	ctx->MD[2] = ctx->MD[3] + ee + aaa;
+	ctx->MD[3] = ctx->MD[4] + aa + bbb;
+	ctx->MD[4] = ctx->MD[0] + bb + ccc;
+	ctx->MD[0] = ddd;
+	ctx->len+=64;
+
+	memset(ctx->X, 0, 16*sizeof(u32));
+	return;
+}
+
+void RIPEMD160_Init(RIPEMD160_CTX *ctx)
+{
+	ctx->MD[0] = 0x67452301UL;
+	ctx->MD[1] = 0xefcdab89UL;
+	ctx->MD[2] = 0x98badcfeUL;
+	ctx->MD[3] = 0x10325476UL;
+	ctx->MD[4] = 0xc3d2e1f0UL;
+	ctx->len=ctx->l=0;
+	return;
+}
+
+void RIPEMD160_Update(RIPEMD160_CTX *ctx, const void *data, u32 size)
+{
+	u8 *message=(u8 *)data;
+	u32 i,bytes;
+
+	/* process message in 16-word chunks */
+	for (bytes=size; bytes > 63; bytes-=64) {
+		for (i=0; i<16; i++) {
+			ctx->X[i] = bytes_TO_u32(message); message += 4;
+		}
+		compress(ctx);
+	}
+
+	/* XXX, is this correct:
+	 * - I process firstly the chunks
+	 * - then I add the rest to the data... ist this really okay?
+	 * - Tino Reichardt <crypto@mcmilk.de>
+	 */
+	if (bytes+ctx->l >= 64) {
+		u8 *m=ctx->D;
+		memcpy(m+ctx->l, message, 64-ctx->l);
+		for (i=0; i<16; i++) {
+			ctx->X[i] = bytes_TO_u32(m); m += 4;
+		}
+		compress(ctx);
+		bytes-=64-ctx->l; message+=64-ctx->l; ctx->l=0;
+	}
+
+	if (bytes > 0) {
+		memcpy(ctx->D+ctx->l, message, bytes);
+		ctx->l+=bytes;
+	}
+
+	return;
+}
+
+void RIPEMD160_Final(u8 *result, RIPEMD160_CTX *ctx)
+{
+	int i,bytes=ctx->len+ctx->l;
+	u8 *message=ctx->D;
+
+	memset(ctx->X, 0, 16 * sizeof(u32));
+
+	for (i=0; i<(bytes&63); i++) {
+		ctx->X[i>>2] ^= (u32) *message++ << (8*(i&3));
+	}
+	ctx->X[(bytes>>2)&15] ^= (u32)1 << (8*(bytes&3) + 7);
+	if ((bytes & 63) > 55) { compress(ctx); }
+	ctx->X[14] = bytes << 3;
+	ctx->X[15] = bytes >> 29;
+	compress(ctx);
+	for (i=0; i<20; i+=4) {
+		result[i]   =  ctx->MD[i>>2];
+		result[i+1] = (ctx->MD[i>>2] >>  8);
+		result[i+2] = (ctx->MD[i>>2] >> 16);
+		result[i+3] = (ctx->MD[i>>2] >> 24);
+	}
+
+	return;
+}
+#undef F
+#undef FF
+#undef FFF
+#undef G
+#undef GG
+#undef GGG
+#undef H
+#undef HH
+#undef HHH
+#undef I
+#undef II
+#undef III
+#undef J
+#undef JJ
+#undef JJJ
+#undef ROL
+#undef bytes_TO_u32
diff -urN qmail-1.03-vanilla/ripemd.h qmail-1.03-md24/ripemd.h
--- qmail-1.03-vanilla/ripemd.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/ripemd.h	2007-07-19 22:22:33.000000000 +0200
@@ -0,0 +1,19 @@
+#ifndef QP_RMD_H
+#define QP_RMD_H
+
+#include "typesx.h"
+#include <string.h>
+
+typedef struct {
+	u32 MD[5]; /* used for the digest */
+	u32 X[16]; /* current 16 bit chunk */
+	u32 len;   /* full length */
+	u8  D[64]; /* 512 bit data block */
+	u32 l;     /* current length of data block -> D[l] */
+} RIPEMD160_CTX;
+
+void RIPEMD160_Init(RIPEMD160_CTX *ctx);
+void RIPEMD160_Update(RIPEMD160_CTX *ctx, const void *data, u32 size);
+void RIPEMD160_Final(u8 *result, RIPEMD160_CTX *ctx);
+
+#endif
diff -urN qmail-1.03-vanilla/scan.h qmail-1.03-md24/scan.h
--- qmail-1.03-vanilla/scan.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/scan.h	2007-07-19 20:56:22.000000000 +0200
@@ -23,5 +23,6 @@
 extern unsigned int scan_memcmp();
 
 extern unsigned int scan_long();
+extern unsigned int scan_8long();
 
 #endif
diff -urN qmail-1.03-vanilla/seek_cur.c qmail-1.03-md24/seek_cur.c
--- qmail-1.03-vanilla/seek_cur.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/seek_cur.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <sys/types.h>
 #include "seek.h"
 
 #define CUR 1 /* sigh */
diff -urN qmail-1.03-vanilla/seek_end.c qmail-1.03-md24/seek_end.c
--- qmail-1.03-vanilla/seek_end.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/seek_end.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <sys/types.h>
 #include "seek.h"
 
 #define END 2 /* sigh */
diff -urN qmail-1.03-vanilla/seek.h qmail-1.03-md24/seek.h
--- qmail-1.03-vanilla/seek.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/seek.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,9 @@
 #ifndef SEEK_H
 #define SEEK_H
 
+#include <sys/types.h>
+#include <unistd.h>
+
 typedef unsigned long seek_pos;
 
 extern seek_pos seek_cur();
diff -urN qmail-1.03-vanilla/seek_set.c qmail-1.03-md24/seek_set.c
--- qmail-1.03-vanilla/seek_set.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/seek_set.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <sys/types.h>
 #include "seek.h"
 
 #define SET 0 /* sigh */
diff -urN qmail-1.03-vanilla/seek_trunc.c qmail-1.03-md24/seek_trunc.c
--- qmail-1.03-vanilla/seek_trunc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/seek_trunc.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <sys/types.h>
 #include "seek.h"
 
 int seek_trunc(fd,pos) int fd; seek_pos pos;
diff -urN qmail-1.03-vanilla/sendmail.c qmail-1.03-md24/sendmail.c
--- qmail-1.03-vanilla/sendmail.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/sendmail.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "sgetopt.h"
 #include "substdio.h"
 #include "subfd.h"
@@ -37,6 +39,37 @@
   _exit(111);
 }
 
+void do_sender(const char *s)
+{
+  char *x;
+  int n;
+  int a;
+  int i;
+  
+  env_unset("QMAILNAME");
+  env_unset("MAILNAME");
+  env_unset("NAME");
+  env_unset("QMAILHOST");
+  env_unset("MAILHOST");
+
+  n = str_len(s);
+  a = str_rchr(s, '@');
+  if (a == n)
+  {
+    env_put2("QMAILUSER", s);
+    return;
+  }
+  env_put2("QMAILHOST", s + a + 1);
+
+  x = (char *) alloc((a + 1) * sizeof(char));
+  if (!x) nomem();
+  for (i = 0; i < a; i++)
+    x[i] = s[i];
+  x[i] = 0;
+  env_put2("QMAILUSER", x);
+  alloc_free(x);
+}
+
 char *qreadarg[] = { "bin/qmail-qread", 0 };
 void mailq()
 {
@@ -48,7 +81,7 @@
 int flagh;
 char *sender;
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -64,8 +97,9 @@
 
   flagh = 0;
   sender = 0;
-  while ((opt = getopt(argc,argv,"vimte:f:p:o:B:F:EJxb:")) != opteof)
+  while ((opt = getopt(argc,argv,"vimte:f:p:o:B:F:EJxb:N:")) != opteof)
     switch(opt) {
+      case 'N': break; /* ignore DSN option */
       case 'B': break;
       case 't': flagh = 1; break;
       case 'f': sender = optarg; break;
@@ -118,6 +152,7 @@
   if (sender) {
     *arg++ = "-f";
     *arg++ = sender;
+    do_sender(sender);
   }
   *arg++ = "--";
   for (i = 0;i < argc;++i) *arg++ = argv[i];
